package service

import (
	"net/http"
	"sghgogs.com/micro/common/errorcode"
	req "sghgogs.com/micro/shopping-service/domain/model/request"
	pb "sghgogs.com/micro/shopping-service/proto"
	"time"
)

func (svc *Service) CreatePayment(add *pb.CreatePaymentRequest) error {
	if err := svc.Repository.CreatePayment(&req.Payment{
		OrderID:       add.OrderId,
		Amount:        add.Amount,
		Status:        add.Status,
		PaymentMethod: add.PaymentMethod,
		CreatedAt:     time.Now(),
		UpdatedAt:     nil,
	}); err != nil {
		return errorcode.New(svc.Namespace, err.Error(), http.StatusBadRequest)
	}
	return nil
}
