package address

import (
	"context"
	"sghgogs.com/micro/shopping-service/domain/service"
	pb "sghgogs.com/micro/shopping-service/proto"
)

type Address struct {
	Service service.IService
}

func (svc *Address) CreateAddress(ctx context.Context, add *pb.CreateAddressRequest, rsp *pb.CreateAddressResponse) error {
	if err := svc.Service.CreateAddress(add); err != nil {
		return err
	}
	return nil
}

func (svc *Address) GetAddressList(ctx context.Context, query *pb.GetAddressListRequest, rsp *pb.GetAddressListResponse) error {
	list, i, err := svc.Service.GetAddressList(query)
	if err != nil {
		return err
	}
	rsp.TotalCount = i
	rsp.Items = list
	return nil
}

func (svc *Address) GetAddress(ctx context.Context, query *pb.GetAddressRequest, rsp *pb.GetAddressResponse) error {
	if address, err := svc.Service.GetAddress(query); err != nil {
		return err
	} else {
		rsp.Data = address
	}
	return nil
}

func (svc *Address) UpdateAddress(ctx context.Context, query *pb.UpdateAddressRequest, rsp *pb.UpdateAddressResponse) error {
	if err := svc.Service.UpdateAddress(query); err != nil {
		return err
	}
	return nil
}

func (svc *Address) DeleteAddress(ctx context.Context, query *pb.DeleteAddressRequest, rsp *pb.DeleteAddressResponse) error {
	if err := svc.Service.DeleteAddress(query); err != nil {
		return err
	}
	return nil
}
