// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/shopping_address_service.proto

package shopping_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ShoppingAddressService service

func NewShoppingAddressServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingAddressService service

type ShoppingAddressService interface {
	CreateAddress(ctx context.Context, in *CreateAddressRequest, opts ...client.CallOption) (*CreateAddressResponse, error)
	GetAddressList(ctx context.Context, in *GetAddressListRequest, opts ...client.CallOption) (*GetAddressListResponse, error)
	GetAddress(ctx context.Context, in *GetAddressRequest, opts ...client.CallOption) (*GetAddressResponse, error)
	UpdateAddress(ctx context.Context, in *UpdateAddressRequest, opts ...client.CallOption) (*UpdateAddressResponse, error)
	DeleteAddress(ctx context.Context, in *DeleteAddressRequest, opts ...client.CallOption) (*DeleteAddressResponse, error)
}

type shoppingAddressService struct {
	c    client.Client
	name string
}

func NewShoppingAddressService(name string, c client.Client) ShoppingAddressService {
	return &shoppingAddressService{
		c:    c,
		name: name,
	}
}

func (c *shoppingAddressService) CreateAddress(ctx context.Context, in *CreateAddressRequest, opts ...client.CallOption) (*CreateAddressResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.CreateAddress", in)
	out := new(CreateAddressResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAddressService) GetAddressList(ctx context.Context, in *GetAddressListRequest, opts ...client.CallOption) (*GetAddressListResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.GetAddressList", in)
	out := new(GetAddressListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAddressService) GetAddress(ctx context.Context, in *GetAddressRequest, opts ...client.CallOption) (*GetAddressResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.GetAddress", in)
	out := new(GetAddressResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAddressService) UpdateAddress(ctx context.Context, in *UpdateAddressRequest, opts ...client.CallOption) (*UpdateAddressResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.UpdateAddress", in)
	out := new(UpdateAddressResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAddressService) DeleteAddress(ctx context.Context, in *DeleteAddressRequest, opts ...client.CallOption) (*DeleteAddressResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.DeleteAddress", in)
	out := new(DeleteAddressResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingAddressService service

type ShoppingAddressServiceHandler interface {
	CreateAddress(context.Context, *CreateAddressRequest, *CreateAddressResponse) error
	GetAddressList(context.Context, *GetAddressListRequest, *GetAddressListResponse) error
	GetAddress(context.Context, *GetAddressRequest, *GetAddressResponse) error
	UpdateAddress(context.Context, *UpdateAddressRequest, *UpdateAddressResponse) error
	DeleteAddress(context.Context, *DeleteAddressRequest, *DeleteAddressResponse) error
}

func RegisterShoppingAddressServiceHandler(s server.Server, hdlr ShoppingAddressServiceHandler, opts ...server.HandlerOption) error {
	type shoppingAddressService interface {
		CreateAddress(ctx context.Context, in *CreateAddressRequest, out *CreateAddressResponse) error
		GetAddressList(ctx context.Context, in *GetAddressListRequest, out *GetAddressListResponse) error
		GetAddress(ctx context.Context, in *GetAddressRequest, out *GetAddressResponse) error
		UpdateAddress(ctx context.Context, in *UpdateAddressRequest, out *UpdateAddressResponse) error
		DeleteAddress(ctx context.Context, in *DeleteAddressRequest, out *DeleteAddressResponse) error
	}
	type ShoppingAddressService struct {
		shoppingAddressService
	}
	h := &shoppingAddressServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingAddressService{h}, opts...))
}

type shoppingAddressServiceHandler struct {
	ShoppingAddressServiceHandler
}

func (h *shoppingAddressServiceHandler) CreateAddress(ctx context.Context, in *CreateAddressRequest, out *CreateAddressResponse) error {
	return h.ShoppingAddressServiceHandler.CreateAddress(ctx, in, out)
}

func (h *shoppingAddressServiceHandler) GetAddressList(ctx context.Context, in *GetAddressListRequest, out *GetAddressListResponse) error {
	return h.ShoppingAddressServiceHandler.GetAddressList(ctx, in, out)
}

func (h *shoppingAddressServiceHandler) GetAddress(ctx context.Context, in *GetAddressRequest, out *GetAddressResponse) error {
	return h.ShoppingAddressServiceHandler.GetAddress(ctx, in, out)
}

func (h *shoppingAddressServiceHandler) UpdateAddress(ctx context.Context, in *UpdateAddressRequest, out *UpdateAddressResponse) error {
	return h.ShoppingAddressServiceHandler.UpdateAddress(ctx, in, out)
}

func (h *shoppingAddressServiceHandler) DeleteAddress(ctx context.Context, in *DeleteAddressRequest, out *DeleteAddressResponse) error {
	return h.ShoppingAddressServiceHandler.DeleteAddress(ctx, in, out)
}
