// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/shopping_login_service.proto

package shopping_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ShoppingAuthService service

func NewShoppingAuthServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingAuthService service

type ShoppingAuthService interface {
	Login(ctx context.Context, in *LoginRequest, opts ...client.CallOption) (*LoginResponse, error)
	Logout(ctx context.Context, in *LogoutRequest, opts ...client.CallOption) (*LogoutResponse, error)
	Profile(ctx context.Context, in *ProfileRequest, opts ...client.CallOption) (*ProfileResponse, error)
}

type shoppingAuthService struct {
	c    client.Client
	name string
}

func NewShoppingAuthService(name string, c client.Client) ShoppingAuthService {
	return &shoppingAuthService{
		c:    c,
		name: name,
	}
}

func (c *shoppingAuthService) Login(ctx context.Context, in *LoginRequest, opts ...client.CallOption) (*LoginResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAuthService.Login", in)
	out := new(LoginResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAuthService) Logout(ctx context.Context, in *LogoutRequest, opts ...client.CallOption) (*LogoutResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAuthService.Logout", in)
	out := new(LogoutResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAuthService) Profile(ctx context.Context, in *ProfileRequest, opts ...client.CallOption) (*ProfileResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAuthService.Profile", in)
	out := new(ProfileResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingAuthService service

type ShoppingAuthServiceHandler interface {
	Login(context.Context, *LoginRequest, *LoginResponse) error
	Logout(context.Context, *LogoutRequest, *LogoutResponse) error
	Profile(context.Context, *ProfileRequest, *ProfileResponse) error
}

func RegisterShoppingAuthServiceHandler(s server.Server, hdlr ShoppingAuthServiceHandler, opts ...server.HandlerOption) error {
	type shoppingAuthService interface {
		Login(ctx context.Context, in *LoginRequest, out *LoginResponse) error
		Logout(ctx context.Context, in *LogoutRequest, out *LogoutResponse) error
		Profile(ctx context.Context, in *ProfileRequest, out *ProfileResponse) error
	}
	type ShoppingAuthService struct {
		shoppingAuthService
	}
	h := &shoppingAuthServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingAuthService{h}, opts...))
}

type shoppingAuthServiceHandler struct {
	ShoppingAuthServiceHandler
}

func (h *shoppingAuthServiceHandler) Login(ctx context.Context, in *LoginRequest, out *LoginResponse) error {
	return h.ShoppingAuthServiceHandler.Login(ctx, in, out)
}

func (h *shoppingAuthServiceHandler) Logout(ctx context.Context, in *LogoutRequest, out *LogoutResponse) error {
	return h.ShoppingAuthServiceHandler.Logout(ctx, in, out)
}

func (h *shoppingAuthServiceHandler) Profile(ctx context.Context, in *ProfileRequest, out *ProfileResponse) error {
	return h.ShoppingAuthServiceHandler.Profile(ctx, in, out)
}

// Api Endpoints for ShoppingWeChatLoginService service

func NewShoppingWeChatLoginServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingWeChatLoginService service

type ShoppingWeChatLoginService interface {
	WeChatLogin(ctx context.Context, in *WeChatLoginRequest, opts ...client.CallOption) (*WeChatLoginResponse, error)
}

type shoppingWeChatLoginService struct {
	c    client.Client
	name string
}

func NewShoppingWeChatLoginService(name string, c client.Client) ShoppingWeChatLoginService {
	return &shoppingWeChatLoginService{
		c:    c,
		name: name,
	}
}

func (c *shoppingWeChatLoginService) WeChatLogin(ctx context.Context, in *WeChatLoginRequest, opts ...client.CallOption) (*WeChatLoginResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingWeChatLoginService.WeChatLogin", in)
	out := new(WeChatLoginResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingWeChatLoginService service

type ShoppingWeChatLoginServiceHandler interface {
	WeChatLogin(context.Context, *WeChatLoginRequest, *WeChatLoginResponse) error
}

func RegisterShoppingWeChatLoginServiceHandler(s server.Server, hdlr ShoppingWeChatLoginServiceHandler, opts ...server.HandlerOption) error {
	type shoppingWeChatLoginService interface {
		WeChatLogin(ctx context.Context, in *WeChatLoginRequest, out *WeChatLoginResponse) error
	}
	type ShoppingWeChatLoginService struct {
		shoppingWeChatLoginService
	}
	h := &shoppingWeChatLoginServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingWeChatLoginService{h}, opts...))
}

type shoppingWeChatLoginServiceHandler struct {
	ShoppingWeChatLoginServiceHandler
}

func (h *shoppingWeChatLoginServiceHandler) WeChatLogin(ctx context.Context, in *WeChatLoginRequest, out *WeChatLoginResponse) error {
	return h.ShoppingWeChatLoginServiceHandler.WeChatLogin(ctx, in, out)
}

// Api Endpoints for ShoppingWeChatPhoneLoginService service

func NewShoppingWeChatPhoneLoginServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingWeChatPhoneLoginService service

type ShoppingWeChatPhoneLoginService interface {
	PhoneLogin(ctx context.Context, in *WeChatPhoneLoginRequest, opts ...client.CallOption) (*WeChatPhoneLoginResponse, error)
}

type shoppingWeChatPhoneLoginService struct {
	c    client.Client
	name string
}

func NewShoppingWeChatPhoneLoginService(name string, c client.Client) ShoppingWeChatPhoneLoginService {
	return &shoppingWeChatPhoneLoginService{
		c:    c,
		name: name,
	}
}

func (c *shoppingWeChatPhoneLoginService) PhoneLogin(ctx context.Context, in *WeChatPhoneLoginRequest, opts ...client.CallOption) (*WeChatPhoneLoginResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingWeChatPhoneLoginService.PhoneLogin", in)
	out := new(WeChatPhoneLoginResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingWeChatPhoneLoginService service

type ShoppingWeChatPhoneLoginServiceHandler interface {
	PhoneLogin(context.Context, *WeChatPhoneLoginRequest, *WeChatPhoneLoginResponse) error
}

func RegisterShoppingWeChatPhoneLoginServiceHandler(s server.Server, hdlr ShoppingWeChatPhoneLoginServiceHandler, opts ...server.HandlerOption) error {
	type shoppingWeChatPhoneLoginService interface {
		PhoneLogin(ctx context.Context, in *WeChatPhoneLoginRequest, out *WeChatPhoneLoginResponse) error
	}
	type ShoppingWeChatPhoneLoginService struct {
		shoppingWeChatPhoneLoginService
	}
	h := &shoppingWeChatPhoneLoginServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingWeChatPhoneLoginService{h}, opts...))
}

type shoppingWeChatPhoneLoginServiceHandler struct {
	ShoppingWeChatPhoneLoginServiceHandler
}

func (h *shoppingWeChatPhoneLoginServiceHandler) PhoneLogin(ctx context.Context, in *WeChatPhoneLoginRequest, out *WeChatPhoneLoginResponse) error {
	return h.ShoppingWeChatPhoneLoginServiceHandler.PhoneLogin(ctx, in, out)
}

// Api Endpoints for ShoppingQQLoginService service

func NewShoppingQQLoginServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingQQLoginService service

type ShoppingQQLoginService interface {
	QQLogin(ctx context.Context, in *QQLoginRequest, opts ...client.CallOption) (*QQLoginResponse, error)
}

type shoppingQQLoginService struct {
	c    client.Client
	name string
}

func NewShoppingQQLoginService(name string, c client.Client) ShoppingQQLoginService {
	return &shoppingQQLoginService{
		c:    c,
		name: name,
	}
}

func (c *shoppingQQLoginService) QQLogin(ctx context.Context, in *QQLoginRequest, opts ...client.CallOption) (*QQLoginResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingQQLoginService.QQLogin", in)
	out := new(QQLoginResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingQQLoginService service

type ShoppingQQLoginServiceHandler interface {
	QQLogin(context.Context, *QQLoginRequest, *QQLoginResponse) error
}

func RegisterShoppingQQLoginServiceHandler(s server.Server, hdlr ShoppingQQLoginServiceHandler, opts ...server.HandlerOption) error {
	type shoppingQQLoginService interface {
		QQLogin(ctx context.Context, in *QQLoginRequest, out *QQLoginResponse) error
	}
	type ShoppingQQLoginService struct {
		shoppingQQLoginService
	}
	h := &shoppingQQLoginServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingQQLoginService{h}, opts...))
}

type shoppingQQLoginServiceHandler struct {
	ShoppingQQLoginServiceHandler
}

func (h *shoppingQQLoginServiceHandler) QQLogin(ctx context.Context, in *QQLoginRequest, out *QQLoginResponse) error {
	return h.ShoppingQQLoginServiceHandler.QQLogin(ctx, in, out)
}

// Api Endpoints for ShoppingAlipayLoginService service

func NewShoppingAlipayLoginServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingAlipayLoginService service

type ShoppingAlipayLoginService interface {
	AlipayLogin(ctx context.Context, in *AlipayLoginRequest, opts ...client.CallOption) (*AlipayLoginResponse, error)
}

type shoppingAlipayLoginService struct {
	c    client.Client
	name string
}

func NewShoppingAlipayLoginService(name string, c client.Client) ShoppingAlipayLoginService {
	return &shoppingAlipayLoginService{
		c:    c,
		name: name,
	}
}

func (c *shoppingAlipayLoginService) AlipayLogin(ctx context.Context, in *AlipayLoginRequest, opts ...client.CallOption) (*AlipayLoginResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAlipayLoginService.AlipayLogin", in)
	out := new(AlipayLoginResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingAlipayLoginService service

type ShoppingAlipayLoginServiceHandler interface {
	AlipayLogin(context.Context, *AlipayLoginRequest, *AlipayLoginResponse) error
}

func RegisterShoppingAlipayLoginServiceHandler(s server.Server, hdlr ShoppingAlipayLoginServiceHandler, opts ...server.HandlerOption) error {
	type shoppingAlipayLoginService interface {
		AlipayLogin(ctx context.Context, in *AlipayLoginRequest, out *AlipayLoginResponse) error
	}
	type ShoppingAlipayLoginService struct {
		shoppingAlipayLoginService
	}
	h := &shoppingAlipayLoginServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingAlipayLoginService{h}, opts...))
}

type shoppingAlipayLoginServiceHandler struct {
	ShoppingAlipayLoginServiceHandler
}

func (h *shoppingAlipayLoginServiceHandler) AlipayLogin(ctx context.Context, in *AlipayLoginRequest, out *AlipayLoginResponse) error {
	return h.ShoppingAlipayLoginServiceHandler.AlipayLogin(ctx, in, out)
}
