// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/shopping_order_service.proto

package shopping_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ShoppingOrderService service

func NewShoppingOrderServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingOrderService service

type ShoppingOrderService interface {
	CreateOrder(ctx context.Context, in *CreateOrderRequest, opts ...client.CallOption) (*CreateOrderResponse, error)
	GetOrderList(ctx context.Context, in *GetOrderListRequest, opts ...client.CallOption) (*GetOrderListResponse, error)
	GetOrder(ctx context.Context, in *GetOrderRequest, opts ...client.CallOption) (*GetOrderResponse, error)
	CreateOrderItem(ctx context.Context, in *CreateOrderItemRequest, opts ...client.CallOption) (*CreateOrderItemResponse, error)
}

type shoppingOrderService struct {
	c    client.Client
	name string
}

func NewShoppingOrderService(name string, c client.Client) ShoppingOrderService {
	return &shoppingOrderService{
		c:    c,
		name: name,
	}
}

func (c *shoppingOrderService) CreateOrder(ctx context.Context, in *CreateOrderRequest, opts ...client.CallOption) (*CreateOrderResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.CreateOrder", in)
	out := new(CreateOrderResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) GetOrderList(ctx context.Context, in *GetOrderListRequest, opts ...client.CallOption) (*GetOrderListResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.GetOrderList", in)
	out := new(GetOrderListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) GetOrder(ctx context.Context, in *GetOrderRequest, opts ...client.CallOption) (*GetOrderResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.GetOrder", in)
	out := new(GetOrderResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) CreateOrderItem(ctx context.Context, in *CreateOrderItemRequest, opts ...client.CallOption) (*CreateOrderItemResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.CreateOrderItem", in)
	out := new(CreateOrderItemResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingOrderService service

type ShoppingOrderServiceHandler interface {
	CreateOrder(context.Context, *CreateOrderRequest, *CreateOrderResponse) error
	GetOrderList(context.Context, *GetOrderListRequest, *GetOrderListResponse) error
	GetOrder(context.Context, *GetOrderRequest, *GetOrderResponse) error
	CreateOrderItem(context.Context, *CreateOrderItemRequest, *CreateOrderItemResponse) error
}

func RegisterShoppingOrderServiceHandler(s server.Server, hdlr ShoppingOrderServiceHandler, opts ...server.HandlerOption) error {
	type shoppingOrderService interface {
		CreateOrder(ctx context.Context, in *CreateOrderRequest, out *CreateOrderResponse) error
		GetOrderList(ctx context.Context, in *GetOrderListRequest, out *GetOrderListResponse) error
		GetOrder(ctx context.Context, in *GetOrderRequest, out *GetOrderResponse) error
		CreateOrderItem(ctx context.Context, in *CreateOrderItemRequest, out *CreateOrderItemResponse) error
	}
	type ShoppingOrderService struct {
		shoppingOrderService
	}
	h := &shoppingOrderServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingOrderService{h}, opts...))
}

type shoppingOrderServiceHandler struct {
	ShoppingOrderServiceHandler
}

func (h *shoppingOrderServiceHandler) CreateOrder(ctx context.Context, in *CreateOrderRequest, out *CreateOrderResponse) error {
	return h.ShoppingOrderServiceHandler.CreateOrder(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) GetOrderList(ctx context.Context, in *GetOrderListRequest, out *GetOrderListResponse) error {
	return h.ShoppingOrderServiceHandler.GetOrderList(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) GetOrder(ctx context.Context, in *GetOrderRequest, out *GetOrderResponse) error {
	return h.ShoppingOrderServiceHandler.GetOrder(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) CreateOrderItem(ctx context.Context, in *CreateOrderItemRequest, out *CreateOrderItemResponse) error {
	return h.ShoppingOrderServiceHandler.CreateOrderItem(ctx, in, out)
}
