package order

import (
	"fmt"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
	"gorm.io/gorm/logger"
	"gorm.io/gorm/schema"
	"sghgogs.com/micro/shopping-service/domain/repository"
	"sghgogs.com/micro/shopping-service/domain/service"
	pb "sghgogs.com/micro/shopping-service/proto"
	"testing"
)

func TestOrder(t *testing.T) {
	address := fmt.Sprintf("%v:%v@(%v:%v)/%v?charset=utf8mb4,utf8&parseTime=True&loc=Local", "root", "xugang131500", "47.56.16.206", 3306, "shopping_wenke")
	db, err := gorm.Open(mysql.Open(address), &gorm.Config{
		Logger: logger.Default.LogMode(logger.Info),
		NamingStrategy: schema.NamingStrategy{
			SingularTable: true,
		}})
	if err != nil {
		t.Fatal(err)
	}
	repo := repository.NewRepository(db)
	newService := service.NewService(repo, "shoppingservice")
	t.Run("创建", func(t *testing.T) {
		newService.CreateOrder(&pb.CreateOrderRequest{
			UserId:        2,
			Status:        1,
			AddressId:     1,
			TotalAmount:   2400,
			PaymentMethod: 0,
		})
	})
	t.Run("创建Item", func(t *testing.T) {
		newService.CreateOrderItem(&pb.CreateOrderItemRequest{
			OrderId:   1,
			ProductId: 1,
			Quantity:  2,
			Subtotal:  2 * 1200,
		})
	})
}
